;;;
;;; Copyright (C) 2010 Frederic Vecoven
;;;
;;; This file is part of NixieClock
;;;
;;; NixieClock is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; NixieClock is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;;
	
; 
; Effect macros
;


;
; MACRO to set tubes to HH:MM
;
HHMM 	MACRO
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_H
	TUBE_VALUE	TUBE_2,     AUTO, HOURS_L 
	TUBE_VALUE	TUBE_3,     AUTO, MINUTES_H
	TUBE_VALUE	TUBE_4,     AUTO, MINUTES_L
	ENDM

;
; MACRO to set tubes to HH:MM + 1 second
;	
HHMM_1 	MACRO
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_1_H
	TUBE_VALUE	TUBE_2,     AUTO, HOURS_1_L 
	TUBE_VALUE	TUBE_3,     AUTO, MINUTES_1_H
	TUBE_VALUE	TUBE_4,     AUTO, MINUTES_1_L
	ENDM

;
; MACRO to set tubes to HH:MM for fading
;
HHMM_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, HOURS_L 
	TUBE_VALUE	TUBE_3_ALT, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_L
	ENDM
	
;
; MACRO to set tubes to HH:MM + 1 second for fading
;
HHMM_1_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, HOURS_1_L 
	TUBE_VALUE	TUBE_3_ALT, AUTO, MINUTES_1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_1_L
	ENDM


;
; MACRO to set HH.. 
;
HH_0 MACRO
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_H
	TUBE_VALUE	TUBE_2,     AUTO, HOURS_L 
	ENDM
	
HH_1 MACRO
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_1_H
	TUBE_VALUE	TUBE_2,     AUTO, HOURS_1_L 
	ENDM
	
HH_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, HOURS_L 
	ENDM
	
HH_1_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, HOURS_1_L 
	ENDM
	
;
; MACRO to set MM.. 
;
MM_0 MACRO
	TUBE_VALUE	TUBE_1,     AUTO, MINUTES_H
	TUBE_VALUE	TUBE_2,     AUTO, MINUTES_L 
	ENDM
	
MM_1 MACRO
	TUBE_VALUE	TUBE_1,     AUTO, MINUTES_1_H
	TUBE_VALUE	TUBE_2,     AUTO, MINUTES_1_L 
	ENDM
	
MM_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, MINUTES_L 
	ENDM
	
MM_1_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, MINUTES_1_L 
	ENDM

;
; MACRO to set ..SS
;
SS_0 MACRO
	TUBE_VALUE	TUBE_3,     AUTO, SECONDS_H
	TUBE_VALUE	TUBE_4,     AUTO, SECONDS_L 
	ENDM
	
SS_1 MACRO
	TUBE_VALUE	TUBE_3,     AUTO, SECONDS_1_H
	TUBE_VALUE	TUBE_4,     AUTO, SECONDS_1_L 
	ENDM
	
SS_ALT MACRO
	TUBE_VALUE	TUBE_3_ALT, AUTO, SECONDS_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_L 
	ENDM
	
SS_1_ALT MACRO
	TUBE_VALUE	TUBE_3_ALT, AUTO, SECONDS_1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_1_L 
	ENDM	

;
; MACRO to set tubes to DD/MM
;
DDMM	MACRO
	TUBE_VALUE	TUBE_1,     AUTO, DAY_H
	TUBE_VALUE	TUBE_2,     AUTO, DAY_L 
	TUBE_VALUE	TUBE_3,     AUTO, MONTH_H
	TUBE_VALUE	TUBE_4,     AUTO, MONTH_L
	ENDM

;
; MACRO to set tubes to DD/MM + 1 second
;
DDMM_1	MACRO
	TUBE_VALUE	TUBE_1,     AUTO, DAY_1_H
	TUBE_VALUE	TUBE_2,     AUTO, DAY_1_L 
	TUBE_VALUE	TUBE_3,     AUTO, MONTH_1_H
	TUBE_VALUE	TUBE_4,     AUTO, MONTH_1_L
	ENDM
	
;
; MACRO to set tubes to DD/MM for fading
;
DDMM_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, AUTO, DAY_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, DAY_L 
	TUBE_VALUE	TUBE_3_ALT, AUTO, MONTH_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, MONTH_L
	ENDM

;
; MACRO to set tubes to DD/MM for fading
;
DDMM_1_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, AUTO, DAY_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, DAY_1_L 
	TUBE_VALUE	TUBE_3_ALT, AUTO, MONTH_1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, MONTH_1_L
	ENDM

;
; MACRO to set tubes to 20YY 
;
YYYY MACRO
	TUBE_VALUE	TUBE_1, DIRECT, 2
	TUBE_VALUE	TUBE_2, DIRECT, 0 
	TUBE_VALUE	TUBE_3, AUTO, YEAR_H
	TUBE_VALUE	TUBE_4, AUTO, YEAR_L
	ENDM
	
YYYY_1 MACRO
	TUBE_VALUE	TUBE_1, DIRECT, 2
	TUBE_VALUE	TUBE_2, DIRECT, 0 
	TUBE_VALUE	TUBE_3, AUTO, YEAR_1_H
	TUBE_VALUE	TUBE_4, AUTO, YEAR_1_L
	ENDM
	
YYYY_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, DIRECT, 2
	TUBE_VALUE	TUBE_2_ALT, DIRECT, 0 
	TUBE_VALUE	TUBE_3_ALT, AUTO, YEAR_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, YEAR_L
	ENDM

YYYY_1_ALT MACRO
	TUBE_VALUE	TUBE_1_ALT, DIRECT, 2
	TUBE_VALUE	TUBE_2_ALT, DIRECT, 0 
	TUBE_VALUE	TUBE_3_ALT, AUTO, YEAR_1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, YEAR_1_L
	ENDM



;;;
;;; Transition to YYYY (duration = 1s)
;;;
EFFECT_TO_YYYY MACRO when, fading_speed
	ACTION	(when)
	TUBE_FADING	TUBE_ALL, FADING, fading_speed
	YYYY_ALT
	END_ACTION
	ACTION	((when) + 4)
	YYYY
	YYYY_1_ALT
	END_ACTION
	ENDM

;;;
;;; Transition to DDMM (duration = 1s)
;;;
EFFECT_TO_DDMM MACRO when, fading_speed
	ACTION	(when)
	TUBE_FADING	TUBE_ALL, FADING, fading_speed	
	DDMM_ALT
	END_ACTION
	ACTION	((when) + 4)
	DDMM
	DDMM_1_ALT
	END_ACTION
	ENDM

;;;
;;; Transition to HHMM (duration = 1s)
;;;
EFFECT_TO_HHMM MACRO when, fading_speed
	ACTION	(when)
	TUBE_FADING	TUBE_ALL, FADING, fading_speed	
	HHMM_ALT
	END_ACTION
	ACTION	((when) + 4)
	HHMM
	HHMM_1_ALT
	END_ACTION
	ENDM
	
;;;
;;; Empty the display by shifting to the left
;;; 
;;; ABCD - BCD. - CD.. - D... - ...
;;;
;;; Duration = 4 * delta
;;; 
EFFECT_EMPTY_LEFT MACRO when, delta
	ACTION		((when))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_44, DIRECT, 0xf
	END_ACTION
	ACTION		((when)+(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_44, DIRECT, 0xf
	END_ACTION
	ACTION		((when)+2*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_44, DIRECT, 0xf
	END_ACTION
	ACTION		((when)+3*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_44, DIRECT, 0xf
	END_ACTION
	ENDM
	
;;;
;;; Empty the display by shifting to the right
;;;
;;; ABCD - .ABC - ..AB - ...A - ....
;;;
;;; Duration = 4 * delta
;;;
EFFECT_EMPTY_RIGHT MACRO when, delta
	ACTION		(when)
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xf
	END_ACTION
	ACTION		((when)+(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xf
	END_ACTION
	ACTION		((when)+2*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xf
	END_ACTION
	ACTION		((when)+3*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_11, DIRECT, 0xf
	END_ACTION
	ENDM	
	
;;;
;;; Shift in HHMM, from the left
;;;
;;; Duration = 4 * delta
;;; 
EFFECT_SHIFT_LEFT_HHMM MACRO when, delta
	ACTION		(when)
	TUBE_VALUE	TUBE_1,     AUTO, MINUTES_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_L
	END_ACTION
	ACTION		((when)+(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, MINUTES_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
	END_ACTION
	ACTION		((when)+2*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_L
	END_ACTION
	ACTION		((when)+3*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
	END_ACTION
	ENDM

;;;
;;; Shift in HHMMSS, from the left (ends with HHMM)
;;;
;;; Duration = 6 * delta
;;; 
EFFECT_SHIFT_LEFT_HHMMSS MACRO when, delta
	ACTION		(when)
	TUBE_VALUE	TUBE_1,     AUTO, SECONDS_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, SECONDS_1_L
	END_ACTION
	ACTION		((when)+(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, SECONDS_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, SECONDS_1_H
	END_ACTION
	ACTION		((when)+2*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, MINUTES_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_L
	END_ACTION
	ACTION		((when)+3*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, MINUTES_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
	END_ACTION
#if 0
	ACTION		((when)+4*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_L
	END_ACTION
	ACTION		((when)+5*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
	END_ACTION
#endif
	ENDM

;;;
;;; Shift in DDMM, from the left
;;;
;;; Duration = 4 * delta
;;; 
EFFECT_SHIFT_LEFT_DDMM MACRO when, delta
	ACTION		(when)
	TUBE_VALUE	TUBE_1,     AUTO, MONTH_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, MONTH_1_L
	END_ACTION
	ACTION		((when)+(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, MONTH_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, MONTH_1_H
	END_ACTION
	ACTION		((when)+2*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, DAY_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, DAY_1_L
	END_ACTION
	ACTION		((when)+3*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, DAY_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, DAY_1_H
	END_ACTION
	ENDM

;;;
;;; Shift in YYYY, from the left
;;;
;;; Duration = 4 * delta
;;; 
EFFECT_SHIFT_LEFT_YYYY MACRO when, delta
	ACTION		(when)
	TUBE_VALUE	TUBE_1,     AUTO, YEAR_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, YEAR_1_L
	END_ACTION
	ACTION		((when)+(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_1,     AUTO, YEAR_H
	TUBE_VALUE	TUBE_1_ALT, AUTO, YEAR_1_H
	END_ACTION
	ACTION		((when)+2*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_11,    DIRECT, 0
	END_ACTION
	ACTION		((when)+3*(delta))
	ROTATE		RIGHT
	TUBE_VALUE	TUBE_11,    DIRECT, 2
	END_ACTION
	ENDM
	
;;;
;;; Shift in HHMM, from the right
;;;
;;; Duration = 4 * delta
;;; 
EFFECT_SHIFT_RIGHT_HHMM MACRO when, delta
	ACTION		(when)
	TUBE_VALUE	TUBE_4,     AUTO, HOURS_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, HOURS_1_H
	END_ACTION
	ACTION		((when)+(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, HOURS_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, HOURS_1_L
	END_ACTION
	ACTION		((when)+2*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, MINUTES_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_1_H
	END_ACTION
	ACTION		((when)+3*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, MINUTES_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_1_L
	END_ACTION
	ENDM

;;;
;;; Shift in HHMMSS, from the right (ends with MMSS)
;;;
;;; Duration = 6 * delta
;;;
EFFECT_SHIFT_RIGHT_HHMMSS MACRO when, delta
	EFFECT_SHIFT_RIGHT_HHMM	when, delta
	ACTION		((when)+4*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, SECONDS_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_1_H
	END_ACTION
	ACTION		((when)+5*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, SECONDS_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_1_L
	END_ACTION
	ENDM


;;;
;;; Shift in DDMM, from the right
;;;
;;; Duration = 4 * delta
;;; 
EFFECT_SHIFT_RIGHT_DDMM MACRO when, delta
	ACTION		(when)
	TUBE_VALUE	TUBE_4,     AUTO, DAY_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, DAY_1_H
	END_ACTION
	ACTION		((when)+(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, DAY_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, DAY_1_L
	END_ACTION
	ACTION		((when)+2*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, MONTH_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, MONTH_1_H
	END_ACTION
	ACTION		((when)+3*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, MONTH_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, MONTH_1_L
	END_ACTION
	ENDM

;;;
;;; Shift in YYYY, from the right
;;;
;;; Duration = 4 * delta
;;; 
EFFECT_SHIFT_RIGHT_YYYY MACRO when, delta
	ACTION		(when)
	TUBE_VALUE	TUBE_44,    DIRECT, 2
	END_ACTION
	ACTION		((when)+(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_44,     DIRECT, 0
	END_ACTION
	ACTION		((when)+2*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, YEAR_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, YEAR_1_H
	END_ACTION
	ACTION		((when)+3*(delta))
	ROTATE		LEFT
	TUBE_VALUE	TUBE_4,     AUTO, YEAR_L
	TUBE_VALUE	TUBE_4_ALT, AUTO, YEAR_1_L
	END_ACTION
	ENDM

;;;
;;; Set auto-increment from left to right 
;;;   (fading is getting disabled)
;;;
;;; Duration = 4 * delta
;;;
EFFECT_INCREMENT_LEFT_TO_RIGHT MACRO when, delta, speed
	if (delta) == 0
		ACTION		(when)
		TUBE_FADING	TUBE_ALL, FADING, NO_FADING
		TUBE_VALUE	TUBE_ALL, INCREMENT, speed
		END_ACTION
	else
		ACTION		(when)
		TUBE_FADING	TUBE_11, FADING, NO_FADING
		TUBE_VALUE	TUBE_11, INCREMENT, speed
		END_ACTION
		ACTION		((when)+(delta))
		TUBE_FADING	TUBE_22, FADING, NO_FADING
		TUBE_VALUE	TUBE_22, INCREMENT, speed
		END_ACTION
		ACTION		((when)+2*(delta))
		TUBE_FADING	TUBE_33, FADING, NO_FADING
		TUBE_VALUE	TUBE_33, INCREMENT, speed
		END_ACTION
		ACTION		((when)+3*(delta))
		TUBE_FADING	TUBE_44, FADING, NO_FADING
		TUBE_VALUE	TUBE_44, INCREMENT, speed
		END_ACTION
	endif
	ENDM

;;;
;;; Set auto-increment from right to left
;;;   (fading is getting disabled)
;;;
;;; Duration = 4 * delta
;;; 
EFFECT_INCREMENT_RIGHT_TO_LEFT MACRO when, delta, speed
	if (delta) == 0
		ACTION		(when)
		TUBE_FADING	TUBE_ALL, FADING, NO_FADING
		TUBE_VALUE	TUBE_ALL, INCREMENT, speed
		END_ACTION
	else
		ACTION		(when)
		TUBE_FADING	TUBE_44, FADING, NO_FADING
		TUBE_VALUE	TUBE_44, INCREMENT, speed
		END_ACTION
		ACTION		((when)+(delta))
		TUBE_FADING	TUBE_33, FADING, NO_FADING
		TUBE_VALUE	TUBE_33, INCREMENT, speed
		END_ACTION
		ACTION		((when)+2*(delta))
		TUBE_FADING	TUBE_22, FADING, NO_FADING
		TUBE_VALUE	TUBE_22, INCREMENT, speed
		END_ACTION
		ACTION		((when)+3*(delta))
		TUBE_FADING	TUBE_11, FADING, NO_FADING
		TUBE_VALUE	TUBE_11, INCREMENT, speed
		END_ACTION
	endif
	ENDM