;;;
;;; Copyright (C) 2010 Frederic Vecoven
;;;
;;; This file is part of NixieClock
;;;
;;; NixieClock is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; NixieClock is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;;
	
;
; Clock animation program
;
	include hv.inc
	include program.inc
	include effects.inc

	
clock_prog_code	CODE_PACK

;;; day of week. 0=Sunday. Remember to keep entries sorted !
day_prog
	GLOBAL	day_prog
	
	ACTION		SUNDAY
	HOUR_PTR	hour_prog_0
	END_ACTION
	
	END_PROGRAM
	

hour_prog_0
	ACTION		.0
	MINUTE_PTR	minute_prog_0
	END_ACTION
	
	END_PROGRAM


minute_prog_0

	ACTION		.0
	QSEC_PTR	q_demo3
	END_ACTION
		
	END_PROGRAM


q_demo3
	ACTION		.0
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0x8
	TUBE_FADING	TUBE_1, FADING, 0xF
	TUBE_FADING	TUBE_2, FADING, 0xB
	TUBE_FADING	TUBE_3, FADING, 0x7
	TUBE_FADING	TUBE_4, FADING, 0x3
	TUBE_VALUE	TUBE_1 | TUBE_2 | TUBE_3 | TUBE_4, AUTO, SECONDS_L
	TUBE_VALUE	TUBE_1_ALT | TUBE_2_ALT | TUBE_3_ALT | TUBE_4_ALT , AUTO, SECONDS_1_L

	END_ACTION
	
	END_PROGRAM
	

;;;
;;; demo1
;;;
q_demo1
	ACTION		.0
	SET_CLOCK_OPTIONS	 OPT_MODE12
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0x8
	TUBE_FADING	TUBE_ALL, FADING, 0x7	
	TUBE_VALUE	TUBE_1,     AUTO, HOURS_H
	TUBE_VALUE	TUBE_2,	    AUTO, HOURS_L
	TUBE_VALUE	TUBE_3,     AUTO, HOURS24_H
	TUBE_VALUE	TUBE_4,     AUTO, HOURS24_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, HOURS_1_L
	TUBE_VALUE	TUBE_3_ALT, AUTO, HOURS24_1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, HOURS24_1_L
	END_ACTION

	END_PROGRAM
	
q_demo2
	ACTION		.0
	SET_CLOCK_OPTIONS	 OPT_MODE12 | OPT_MMDD
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0x8
	TUBE_FADING	TUBE_ALL, FADING, 0x7	
	TUBE_VALUE	TUBE_11,     AUTO, DATE_PART1_H
	TUBE_VALUE	TUBE_22,     AUTO, DATE_PART1_L
	TUBE_VALUE	TUBE_33,     AUTO, DATE_PART2_H
	TUBE_VALUE	TUBE_44,     AUTO, DATE_PART2_L
	END_ACTION

	END_PROGRAM	
	
;;;
;;; demo0
;;; 
q_demo0
	ACTION		.0
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0xC
	TUBE_VALUE	TUBE_1,     AUTO, MINUTES_H
	TUBE_VALUE	TUBE_2,     AUTO, MINUTES_L
	TUBE_VALUE	TUBE_3,     AUTO, SECONDS_H
	TUBE_VALUE	TUBE_4,     AUTO, SECONDS_L 	
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, MINUTES_1_L
	TUBE_VALUE	TUBE_3_ALT, AUTO, SECONDS_1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_1_L
	TUBE_FADING	TUBE_1 | TUBE_2, FADING, 0xf
	TUBE_FADING	TUBE_3 | TUBE_4, FADING, 0x7
	END_ACTION

	ACTION		.40
	TUBE_BRIGHT	TUBE_1, CYCLE, EVERY_1_16_S
	TUBE_BRIGHT	TUBE_2, CYCLE, EVERY_1_8_S
	TUBE_BRIGHT	TUBE_3, CYCLE, EVERY_1_4_S
	TUBE_BRIGHT	TUBE_4, CYCLE, EVERY_1_2_S	
	END_ACTION

	ACTION		.80
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0xC
	END_ACTION

	EFFECT_EMPTY_LEFT	.120, .2
	
	EFFECT_SHIFT_LEFT_DDMM	.140, .2

	EFFECT_TO_HHMM	.160, 0x7
	
	EFFECT_INCREMENT_RIGHT_TO_LEFT	.180, .2, EVERY_1_8_S

	ACTION		.200
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0xC
	TUBE_VALUE	TUBE_1,     AUTO, MINUTES_H
	TUBE_VALUE	TUBE_2,     AUTO, MINUTES_L
	TUBE_VALUE	TUBE_3,     AUTO, SECONDS_H
	TUBE_VALUE	TUBE_4,     AUTO, SECONDS_L 	
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, MINUTES_1_L
	TUBE_VALUE	TUBE_3_ALT, AUTO, SECONDS_1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_1_L
	TUBE_FADING	TUBE_1 | TUBE_2, FADING, 0xF	
	TUBE_FADING	TUBE_3 | TUBE_4, FADING, 0x7
	END_ACTION	

	END_PROGRAM
	
	
	

;
; MM:SS
;
q_mmss
	ACTION		.0
	MM_0
	MM_1_ALT
	SS_0
	SS_1_ALT
	TUBE_FADING	TUBE_1 | TUBE_2, FADING, 0xF
	TUBE_FADING	TUBE_3 | TUBE_4, FADING, 0x7
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0xF
	END_ACTION
	
	END_PROGRAM


;;;
;;; test new fading
;;;
q_fade
	ACTION		.0
	MM_0
	MM_1_ALT
	SS_0
	SS_1_ALT
	TUBE_BRIGHT	TUBE_ALL, DIRECT, 0xA
	TUBE_FADING	TUBE_ALL, FADING, 0x7
	END_ACTION

	END_PROGRAM
	

	
	
	
;
; test power
;
q_test_power
	ACTION		.0
	MM_0
	MM_1_ALT
	SS_0
	SS_1_ALT
	TUBE_FADING	TUBE_ALL, FADING, 0x7
	END_ACTION
	
	ACTION		.40
	SET_POWER_OFF
	END_ACTION
	
	ACTION		.80
	SET_POWER_ON
	END_ACTION

	
	END_PROGRAM	

;	
; one minute with :
;
; 00 HH:MM
; 10 switch to date
q_hhmm
	ACTION		.0
	MM_0
	MM_1_ALT
	SS_0
	SS_1_ALT
	END_ACTION

	EFFECT_TO_HHMM	.16, 0xF
	
	ACTION		.36
	DDMM_ALT
	TUBE_FADING	TUBE_ALL, FADING, 0xF
	END_ACTION
	
	ACTION		.40
	DDMM
	END_ACTION
	
	ACTION		.56
	YYYY_ALT	
	END_ACTION
	
	ACTION		.60
	YYYY
	END_ACTION
	
	ACTION		.76
	TUBE_BRIGHT	TUBE_ALL, DECREMENT, EVERY_1_8_S
	END_ACTION

	EFFECT_EMPTY_LEFT	.84, .2	
	
	EFFECT_SHIFT_LEFT_HHMM	.100, .2
	
	ACTION		.120
	TUBE_BRIGHT	TUBE_ALL, INCREMENT, EVERY_1_8_S
	END_ACTION
	
	EFFECT_INCREMENT_LEFT_TO_RIGHT	.160, .4, EVERY_1_8_S
	
	EFFECT_EMPTY_RIGHT  .210, .2
	
	ACTION		.231
	TUBE_FADING	TUBE_ALL, FADING, 0xF
	END_ACTION
	
	EFFECT_SHIFT_LEFT_HHMMSS .236, .1
	
	END_PROGRAM
	
	
	
	
	
	
qsec_0_rand
	ACTION		.0
	QSEC_RAND_PTR	.5
		SUB	qsec_prog_1
		SUB	qsec_prog_0
		SUB	qsec_prog_1
		SUB	qsec_prog_1
		SUB	qsec_prog_0
	END_ACTION
	END_PROGRAM
	
qsec_prog_0
	ACTION		.0
	TUBE_VALUE	TUBE_1, AUTO, HOURS_H
	TUBE_VALUE	TUBE_2, AUTO, HOURS_L 
	TUBE_VALUE	TUBE_3, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_4, AUTO, MINUTES_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, HOURS_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, HOURS_1_L 
	TUBE_VALUE	TUBE_3_ALT, AUTO, MINUTES_1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, MINUTES_1_L
	TUBE_FADING	TUBE_ALL, FADING, 0x7
	TUBE_BRIGHT	TUBE_1 | TUBE_3, DIRECT, .15
	TUBE_BRIGHT	TUBE_2 | TUBE_4, DIRECT, .3
	END_ACTION
	
	ACTION		.12
	TUBE_BRIGHT	TUBE_ALL, CYCLE, EVERY_1_8_S
	END_ACTION
	
	ACTION		.80
	TUBE_BRIGHT	TUBE_ALL, DIRECT, .12
	TUBE_VALUE	TUBE_11 | TUBE_22, RANDOM, EVERY_1_8_S
	END_ACTION

	END_PROGRAM	
	
qsec_prog_1
	ACTION		.0
	TUBE_FADING	TUBE_3 | TUBE_4, FADING, 0x7
	TUBE_FADING	TUBE_1 | TUBE_2, FADING, 0xF
	TUBE_BRIGHT	TUBE_ALL, DIRECT, .5
	TUBE_VALUE	TUBE_1, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_2, AUTO, MINUTES_L 
	TUBE_VALUE	TUBE_3, AUTO, SECONDS_H
	TUBE_VALUE	TUBE_4, AUTO, SECONDS_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, MINUTES_1_L
	TUBE_VALUE	TUBE_3_ALT, AUTO, SECONDS_1_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_1_L	
	END_ACTION
	
	END_PROGRAM

	
qsec_prog_2
	ACTION		.0
	TUBE_FADING	TUBE_ALL, DIRECT, .16
	TUBE_BRIGHT	TUBE_ALL, DIRECT, .14
	TUBE_VALUE	TUBE_1, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_2, AUTO, MINUTES_L 
	TUBE_VALUE	TUBE_3, AUTO, MINUTES_H
	TUBE_VALUE	TUBE_4, AUTO, MINUTES_L
	TUBE_VALUE	TUBE_1_ALT, AUTO, MINUTES_1_H
	TUBE_VALUE	TUBE_2_ALT, AUTO, MINUTES_1_L
	TUBE_VALUE	TUBE_3_ALT, AUTO, SECONDS_H
	TUBE_VALUE	TUBE_4_ALT, AUTO, SECONDS_L	
	END_ACTION
	
	END_PROGRAM




	END
	