;;;
;;; Copyright (C) 2010 Frederic Vecoven
;;;
;;; This file is part of NixieClock
;;;
;;; NixieClock is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or
;;; (at your option) any later version.
;;;
;;; NixieClock is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program. If not, see <http://www.gnu.org/licenses/>.
;;;
	
;
; Various tables
;
	include hv.inc

	
	
tables_code	CODE


;
; value table : modify return address by adding W*2 to it
;
value_table
	GLOBAL	value_table
	rlncf	WREG,w
	addwf	TOSL,f
	movlw	0x00
	addwfc	TOSH,f
	;addwfc	TOSU,f			; if more than 64kB
	return

	
remap_digit
	GLOBAL	remap_digit
	andlw	0xF
	call	value_table
	dt	0x1,0x3,0xb,0x8,0xa,0x2,0x4,0xc,0x0,0x9
	dt	0xf,0xf,0xf,0xf,0xf,0xf
	
unmap_digit
	GLOBAL	unmap_digit
	andlw	0xF
	call	value_table
	dt	0x8,0x0,0x5,0x1,0x6,0xf,0xf,0xf,0x3,0x9
	dt	0x4,0x2,0x7,0xf,0xf,0xf
	
; tube number -> offset in 'pair' to its fading setting
remap_fading
	GLOBAL	remap_fading
	andlw	0x3
	call	value_table
	dt	.2, .10, .0, .8
	
; tube number -> offset in 'pair' to its brightness setting
;
; just use remap_fading, then add '1'.
	
	
; tube number -> offset in 'pair' to its digit value
remap_tube
	GLOBAL	remap_tube
	andlw	0x7
	call	value_table
	dt	.5, .7, .13, .15, .4, .6, .12, .14
	
; frequency setting -> mask for 'ticks'
freq_mask
	GLOBAL	freq_mask
	andlw	0x7
	call	value_table
	dt	0xFF,0x7F,0x3F,0x1F,0x0F,0x07,0x03,0x1
	
; number of days per month (in BCD, january offset = 1)
; W input in binary or BCD
days_per_month
	GLOBAL	days_per_month
	call	value_table
	dt	0x00
	dt	0x31,0x28,0x31,0x30,0x31,0x30,0x31,0x31,0x30
	dt	0x31,0x30,0x31
	dt	0x00,0x00,0x00
	dt	0x31,0x30,0x31

; months table [calculation of day of week]
; (January offset = 1)
; W input in binary or BCD
dow_months_table
	GLOBAL	dow_months_table
	call	value_table
	dt	0x0
	dt	0x0,0x3,0x3,0x6,0x1,0x4,0x6,0x2,0x5
	dt	0x0,0x3,0x5
	dt	0x0,0x0,0x0
	dt	0x0,0x3,0x5
	
; same as above, but for leap years (jan and feb are different)
dow_months_table_leap
	GLOBAL	dow_months_table_leap
	call	value_table
	dt	0x0
	dt	0x6,0x2,0x3,0x6,0x1,0x4,0x6,0x2,0x5
	dt	0x0,0x3,0x5
	dt	0x0,0x0,0x0
	dt	0x0,0x3,0x5
	

fading_table
	GLOBAL	fading_table
	call	value_table
	dt	0xff,0x80,0x55,0x40,0x33,0x2a,0x24,0x20
	dt	0x1c,0x19,0x17,0x15,0x13,0x12,0x11,0x10

	
	END
	